%MATRIX2
% Generation of matrix A2
% Partially vectorized version of MATRIX1: more fficient
% Gives computing time on screen

tic	% Start clock
% ..........Vectorized matrix generation by flux evaluation
n = J*K; a1 = zeros(n,1); a2=a1; a3=a1; a4=a1; a5=a1; een=ones(size(a1));
%d = [-J  -1  0  1  J];
%A2 = spdiags([ a1  a2  a3  a4  a5], d',n,n); % Structure of sparse matrix
% A2(j,j-J) is stored in a1(j-J)
% A2(j,j-1) is stored in a2(j-1)
% A2(j,j)   is stored in a3(j)
% A2(j,j+1) is stored in a4(j+1)
% A2(j,j+J) is stored in a5(j+J)
dyr = reshape(DY',n,1);				   
m = 1:J:(K-1)*J+1;				% Cell faces at left boundary
a3(m) = a3(m)+dyr(m);
for k = 1:K			
  aa = dyr*(Da/dx - 1/2); bb = -dyr*(Da/dx + 1/2);	% Cell face fluxes
  m = (k-1)*J+2:k*J; m1 = m-1;				% Vertical cell faces
  a3(m1) = a3(m1) + aa(m1); a4(m) = a4(m) + bb(m);
  a2(m1) = a2(m1) - aa(m1); a3(m) = a3(m) - bb(m);
end
m = J:J:n; a3(m) = a3(m) + 2*Da*dyr(m)/dx; 	% Cell faces at right boundary
m = 1:J; a3(m)= a3(m) + 2*D*dx./dyr(m);    	% Cell faces at lower boundary
aa = 2*dx*D./(dyr(J+1:n) + dyr(1:n-J));		% Cell face fluxes   
for j=1:J					% Loop over horizontal faces;
  m = j+J:J:j+(K-1)*J;
  a3(m-J) = a3(m-J)+aa(m-J); a5(m) = a5(m) - aa(m-J);
  a1(m-J) = a1(m-J)-aa(m-J); a3(m) = a3(m) +aa(m-J);  
end
d = [-J  -1  0  1  J]; A2 = spdiags([ a1  a2  a3  a4  a5], d',n,n); 

time = toc; disp(['matrix A2 time = ',num2str(time)])
