%MATRIX3
% Generation of matrix A3
% Vectorized matrix generation by evaluation of stencil coefficients
%       |   a5    |
% [A] = |a2 a3  a4|
%       |   a1    |
% Gives computing time on screen

tic	% Start clock

am1 = zeros(size(X)); am2=am1; am3=am1; am4=am1; am5=am1; % Preallocations
am1(2:K,:)   = -2*dx*D./(DY(1:K-1,:) + DY(2:K,:));
am2(:,2:J)   =  DY(:,2:J  )*(1/2-Da/dx);
am4(:,1:J-1) = -DY(:,1:J-1)*(1/2+Da/dx);
am5(1:K-1,:) = am1(2:K,:);
am3          = - am1 - am2 - am4 - am5;
am3(:,J) = am3(:,J) + 2*Da*DY(:,J)/dx+DY(:,J);	% Right boundary correction
am3(1,:) = am3(1,:) + 2*D*dx./DY(1,:);		% Lower boundary correction
n = J*K;
a1 = reshape(am1',n,1); a2 = reshape(am2',n,1);
a3 = reshape(am3',n,1); a4 = reshape(am4',n,1); a5 = reshape(am5',n,1);
a1 = [a1(J+1:n); zeros(J,1)];		% Shifts to accomodate spdiags
a2 = [a2(2:n); 0]; a4 = [0; a4(1:n-1)]; a5 = [zeros(J,1); a5(1:n-J)];
d = [-J;  -1;  0;  1;  J]; A3 = spdiags([ a1  a2  a3  a4  a5], d, n, n);
   
time = toc; disp(['Matrix A3 time = ',num2str(time)])
